  program
!! ++++++++++++++++++++++++++++++++++++++++++++++++++++
!  SQLDMO Example to find sizes of existing database files
!  by John Griffiths
!  Size is shown in Megabytes and includes size of data and LOG files combined
!  Enjoy.
!  e-mail:    questions@sqlkey.com   OR   globaljohn@gmail.com
!  
!! ++++++++++++++++++++++++++++++++++++++++++++++++++++
  map
  end
!! display Q of Database sizes by John Griffiths, Kerrville Tx and Perth, Australia.
HowMany         LONG
ii  long
TrustedLogin     byte(1)
ServerName     cstring(41)
LoginName      cstring(21)
LoginPwd       cstring(21)
dbq        queue,pre(dbq)
ix           long
dbname       string(40)
SizeMB       long
           end

window WINDOW(' SQLDMO Current Database Sizes'),AT(,,315,192),CENTER,SYSTEM,GRAY,DOUBLE
       OLE,AT(9,37,40,14),USE(?Ole)
       END
       PROMPT('Collects the size (in Megabytes) of all databases on a MS-SQL Server'),AT(64,93,211,11), |
           USE(?Prompt2),FONT('Arial',9,COLOR:Blue,FONT:regular,CHARSET:ANSI)
       PROMPT('note: May take several seconds to display the results once you click [Do it]'),AT(222,104,82,23), |
           USE(?Prompt3),FONT('Arial',9,COLOR:Red,FONT:regular,CHARSET:ANSI)
       PROMPT('Server:'),AT(40,118),USE(?Prompt5),FONT('Arial',9,,FONT:regular,CHARSET:ANSI)
       LIST,AT(64,2,223,88),USE(?Listdbs),VSCROLL,FORMAT('20L(1)|~IX~@n_4@102L(2)|~database Name~@S40@20L(3)|~SIZE (in MB)~@n11@'), |
           FROM(dbq)
       PROMPT('This is the OLE container used by the program'),AT(1,13,52,22),USE(?Prompt4),FONT('Arial',9,COLOR:Red,FONT:regular,CHARSET:ANSI)
       CHECK('Use Trusted Login'),AT(78,131),USE(TrustedLogin),VALUE('1','0')
       BUTTON('Do it'),AT(232,130,48,16),USE(?DoitButton)
       PROMPT('Login:'),AT(57,147),USE(?LoginPrompt),FONT('Arial',9,,FONT:regular,CHARSET:ANSI)
       PROMPT('By John Griffiths - 2008'),AT(0,182),USE(?Prompt1),FONT(,,COLOR:White,,CHARSET:ANSI),COLOR(0A00000H)
       ENTRY(@s20),AT(79,146,115,10),USE(LoginName),HIDE
       ENTRY(@s40),AT(65,118,115,10),USE(ServerName)
       BUTTON('Close'),AT(231,155,48,16),USE(?CloseButton),STD(STD:Close)
       PROMPT('Passsword:'),AT(42,160),USE(?PasswordPrompt),FONT('Arial',9,,FONT:regular,CHARSET:ANSI)
       ENTRY(@s20),AT(79,160,115,10),USE(LoginPwd),HIDE
     END

  code
  ServerName = '.\SQLExpress'
  LoginName  = 'sa'
  LoginPwd   = 'putYoursHere'
  open(window)
  display()
  accept
    case event()
    of event:openwindow

    of event:User + 111

      ?ole{prop:reportexception}=true
      ?ole{prop:create}='SQLDMO.SQLSERVER'

      if TrustedLogin
        ?ole{'LoginSecure'} = TRUE
        ?ole{'Connect(' & ServerName & ')'}                         !      = '.\sqlexpress'
      else
        ?ole{'connect(' & ServerName &',' & LoginName & ',' & LoginPwd &')' }

      end
      HowMany =  ?ole{'Databases.count'}
      loop  ii= 1 to HowMany
            dbq.ix = ii
            dbq.dbName = ?ole{'databases(' & ii & ').name' }
            dbq.SizeMB = ?ole{'databases(' & ii & ').size' }
            add(dbq)
      end
      sort(dbq, dbq.dbname)
      display()
    END   ! CASE Event

    CASE FIELD()
    OF ?TrustedLogin
       CASE EVENT()
       of event:Accepted
         if TrustedLogin
           hide(?LoginName)
           hide(?LoginPwd)

         else

           unhide(?LoginName)
           unhide(?LoginPwd)

         end
         display()
       end
    OF ?DoitButton
      CASE event()
      OF EVENT:Accepted
        post((event:User + 111) )
      END
    END   ! Case FIELD

 end  ! ACCEPT
 close(window)
 RETURN
