#!Template to override the default Alias behavior in ABC app
#!Bjarne Havnen 2008
#!Cmag 2008
#!
#Template(cmagAliasToFile,'cmag Override Alias behavior'),Family('ABC')
#Extension(TurnAliasToFile,'cmag Turn alias to file'),Application,Multi,Description('Alias To File for'&%OrigFile)
#Prompt('Select Alias File',File),%origFile
#Prompt('New name',Expr),%CopyName
#Prompt('Change keynames',Check),%ChangekeyName
#Prompt('EmaulateAutoNumKey',Check),%SetAutoInc
#ATSTART
   #Declare(%adiKeyName)
#If(Not %Globalexternal)
   #Fix(%File,%OrigFile)
   #Set(%OverrideGenerate,%True)
   #CALL(%SetClassItem(ABC),'RelationManager:' & %OrigFile)
   #Declare(%Found)
   #Declare(%Cnt)
   #Set(%Found,%False)
   #SET(%DeriveFromBaseClass,%True)
   #For(%NewMethods)
     #If(Upper(%NewMethodName)='SETALIAS')
       #Set(%Found,%TRUE)
     #EndIf
     #Set(%Cnt,%Cnt+1)
   #EndFor
   #If(NOt %Found)
       #ADD(%NewMethods,%Cnt+1)
       #SET(%NewMethodName,'SetAlias')
       #SET(%NewMethodPrototype,'(RelationManager RM)')
   #EndIf
#EndIf
#EnDAT
#!
#AT(%FileManagerCodeSection,%OrigFile,'Init','()'),PRIORITY(4600),DESCRIPTION('Alias override'),Where(Not %GlobalExternal)
 #If(Sub(%CopyName,1,1)='!')
 Self.Filename&=%(Sub(%CopyName,2,Len(%CopyName)))  #<!change variabel for SetName()
 #Else
 Self.FileName&=NULL           #<!Can't use the same variable
 #EndIf
 Self.AliasedFile&=NULL        #<!no aliaser 
#EndAT
#!
#AT(%EndOfGetFileStructHeader,%OrigFile),Where(Not %GlobalExternal)
 #Declare(%NewName)
 #If(Sub(%CopyName,1,1)='!')
     #Set(%NewName,'NAME('&Sub(%CopyName,2,Len(%CopyName))&')')
 #Else
     #Set(%NewName,'NAME('''&%CopyName&''')')
 #EndIf
 #Set(%Rval,Replace(%Rval,'NAME',%NewName))
#EndAT
#AT(%BeforeKeyDeclaration,%File),Where(%ChangeKeyName)
#Set(%adiKeyName,'NAME('''&%FilePrefix&'_'&%KeyId&''')')
#SET(%ValueConstruct,Replace(%ValueConstruct,'NAME',%adiKeyName))
#EndAT
#AT(%FileManagerCodeSection,%OrigFile , 'PreInsert', '(SIGNED OpCode,UNSIGNED AddLen,*CSTRING ErrCode,*CSTRING ErrMsg),BYTE'),PRIORITY(101)
#CALL(%GenerateIdentityColumn,%OrigFile)
#ENDAT
#AT(%FileManagerCodeSection,%OrigFile,'UseFile','(BYTE UseType = UseType:Uses),BYTE'),PRIORITY(4045),Where(%SetAutoInc)
IF UseType = UseType:Initialize AND ~SELF.Initialized
   SELF.HasAutoInc = True
END
#EndAT
#!---------------------------------------
#GROUP(%GenerateIdentityColumn,%theAlias)
#DECLARE(%lFileCount)
#Declare(%oldPrefix)
#Fix(%File,%TheAlias)
#Set(%OldPrefix,%FilePrefix)
#Fix(%File,%AliasFile)
#DECLARE(%FileIdentityField)
#DECLARE(%FileIdentityFieldInstance)
#DECLARE(%FileIdentityFieldColumn,LONG)
#SET(%FileIdentityField,'')
#SET(%FileIdentityFieldInstance,0)
#SET(%FileIdentityFieldColumn,1)
#SET(%lFileCount,0)
#FOR(%Field),WHERE(%FieldType<>'MEMO' AND %FieldType<>'BLOB' AND %FieldType<>'END')
      #SET(%lFileCount,%lFileCount+1)
      #IF((EXTRACT(UPPER(%FieldUserOptions), UPPER('IsIdentity'),1) = '1' OR UPPER(EXTRACT(UPPER(%FieldUserOptions), UPPER('IsIdentity'),1)) = 'TRUE') AND %FieldType<>'GROUP')
         #IF(%FileIdentityFieldInstance=0)
            #SET(%FileIdentityField,%oldPrefix&':'&%FieldId)
            #SET(%FileIdentityFieldInstance,%lFileCount)
            #SET(%FileIdentityFieldColumn,1)
         #ELSE
            #ERROR('Only one Identity column per File is allowed - Second instance (File:'&%File&' - Column:'&%Field&')')
         #ENDIF
      #ENDIF
#ENDFOR
#Fix(%File,%TheAlias)
#IF(%FileIdentityFieldInstance<>0)
%TheAlias{PROP:ServerAutoInc}
%TheAlias{PROP:ServerAutoInc,%FileIdentityFieldInstance}=%FileIdentityFieldColumn !%FileIdentityField
   #FOR(%Key),WHERE(%KeyAuto=%FileIdentityField)
      #ERROR('An Identity Column can not belong to an Auto Number Key (Key:'&%Key&' - Column:'&%FileIdentityField&')')
      #ERROR('Set the Auto Number option to false.')
An Identity Column can not belong to an Auto Number Key (Key:%Key - Column:%FileIdentityField)
Set the auto Number option to false.
   #ENDFOR
#EndIf
#RETURN
#!